float4x4 matView;
float4x4 matProj;
float4x4 matWorld;
float4x4 matWorldViewProj;
float3 vecSunDir={0.8,-0.8,0.3};
float4 vecViewPos;
texture entSkin1;

sampler ColorSampler =sampler_state
{
	Texture=<entSkin1>;
	
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	
	AddressU  = wrap;
	AddressV  = wrap;
};

struct VS_OUTPUT
{
	float4 Pos: POSITION;
	float2 Tex: TEXCOORD0;
	float3 Normal:TEXCOORD1;
	float3 Diffuse:COLOR0;
	float3 Specular:COLOR1;
	float  AO	:TEXCOORD2;
	float3 WPos:TEXCOORD3;
	float4 Tex2:	TEXCOORD4;
	float3 BlendWeights:TEXCOORD5;
	float3 View:TEXCOORD6;
};

VS_OUTPUT VS(float4 inPos:POSITION, float3 inNormal:NORMAL, float2 Tex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
//	inPos.x-=75;
//	inPos.y-=75;
//	inPos.z-=75;
	Out.Pos=mul(inPos,matWorldViewProj);//mul(mul(inPos,matView),matProj);
	inNormal=normalize(inNormal);
	Out.WPos=mul(inPos,matWorld);
	Out.Normal=inNormal;//mul(inNormal,matWorld);
	Out.Diffuse=max(0,dot(inNormal,normalize(-vecSunDir)));
	float3 ViewerX = Out.WPos.xyz - vecViewPos.xyz;	
	Out.View=ViewerX;
	float specular=(Out.Diffuse>0)?saturate(pow(saturate(dot(inNormal,normalize(-ViewerX + normalize(-vecSunDir)))),5)):0;
	Out.Specular=specular;
	//	Out.Diffuse=1-Tex.xxx;
	Out.AO=Tex.y;//inNormal.x;//Tex.x;
	
	// Determine the blend weights for the 3 planar projections.
	// N_orig is the vertex-interpolated normal vector.
	float3 blend_weights = abs( normalize(inNormal.xyz) );

	// Tighten up the blending zone:
	blend_weights = (blend_weights - 0.2) * 7;
	blend_weights = max(blend_weights, 0);

	// Force weights to sum to 1.0 (very important!)
	blend_weights /= (blend_weights.x + blend_weights.y +	blend_weights.z ).xxx;
	Out.BlendWeights=blend_weights;
	Out.Tex=Out.WPos.yz*0.005;
	Out.Tex2.zw=Out.WPos.xy*0.005;
	Out.Tex2.xy=Out.WPos.xz*0.005;


	return Out;
}


float4 PS(VS_OUTPUT In):COLOR0
{
	float4 color;
	// Use warped world-space coordinate to generate a marble texture.
	float4 color1=tex2D(ColorSampler,In.Tex);
	float4 color2=tex2D(ColorSampler,In.Tex2.xy);
	float4 color3=tex2D(ColorSampler,In.Tex2.zw);
	color=color1*In.BlendWeights.x+color2*In.BlendWeights.y+color3*In.BlendWeights.z;
//	In.Diffuse=0.84;
//	color.rgb=float3(0.6,1,0.4);
//	color.rgb*=float3(0.5,0.7,0.9);
//	color.rgb=lerp(color.rgb*float3(0.5,0.7,0.9),color.rgb*float3(0.4,0.7,0.2),saturate((In.WPos.y-1675)/20));
	color.rgb=lerp(color.rgb*float3(0.5,0.7,0.9),color.rgb*float3(0.4,0.7,0.2),saturate((In.WPos.y-2540)/20));
//	color.rgb=lerp(color.rgb*float3(0.5,0.7,0.9),color.rgb*float3(0.4,0.7,0.2),saturate((In.WPos.y-5040)/20));
//	color.rgb=lerp(color.rgb,color.rgb*float3(1,0,0),length(In.WPos.xy)/500);
//	color.rgb*=(0.5+In.Diffuse)*saturate(1 - 1.2*In.AO)*1;
//	In.AO=1;
	float ao=saturate(1.5*In.AO);
	color.rgb*=saturate(1.5*In.AO);
	color.rgb*=(0.25+In.Diffuse*float3(0.7,0.5,0.4))*2*ao;
//	color.rgb=In.Diffuse;
//	color.rgb*=(0.5+In.Diffuse*float3(0.9,0.7,0.8))*2;
//	color.r+=saturate(1-(In.WPos.y-800)/500)*0.7;
//	color.rgb*=(0.5+abs(In.Normal.y)*float3(1,0.3,0.2))*2;
////	color.rgb*=length(In.WPos.xy)/200;
//	color.rgb=In.AO;//pow(In.AO,1.3)*2;//saturate(1 - 1.2*In.AO);
//	color.rgb=normalize(In.Normal)/2.0+0.5;

//	float3 ViewerX = In.WPos.xyz - vecViewPos.xyz;	
//	float3 atmo=pow(1-saturate(dot(In.Normal,normalize(-In.View))),1)*In.Diffuse;
//	atmo*=float3(0.1,0.4,1.0)*2;
//	color.rgb*=In.Diffuse+atmo+In.Specular*In.Diffuse;
	color.a=1;
	return color;	
}



VS_OUTPUT VS_atmo(float4 inPos:POSITION, float3 inNormal:NORMAL, float2 Tex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
//	inPos.x-=75;
//	inPos.y-=75;
//	inPos.z-=75;
//	inNormal=normalize(inNormal);
	inPos.xyz+=inNormal*15;
	Out.Pos=mul(inPos,matWorldViewProj);//mul(mul(inPos,matView),matProj);
	Out.WPos=mul(inPos,matWorld);
	Out.Normal=inNormal;//mul(inNormal,matWorld);
	Out.Diffuse=max(0,dot(inNormal,normalize(-vecSunDir)));
	float3 ViewerX = Out.WPos.xyz - vecViewPos.xyz;	
	Out.View=ViewerX;
	float specular=(Out.Diffuse>0)?saturate(pow(saturate(dot(inNormal,normalize(-ViewerX + normalize(-vecSunDir)))),5)):0;
	Out.Specular=specular;
	//	Out.Diffuse=1-Tex.xxx;
	Out.AO=inNormal.x;//Tex.x;
	
	// Determine the blend weights for the 3 planar projections.
	// N_orig is the vertex-interpolated normal vector.
	float3 blend_weights = abs( normalize(inNormal.xyz) );

	// Tighten up the blending zone:
	blend_weights = (blend_weights - 0.2) * 7;
	blend_weights = max(blend_weights, 0);

	// Force weights to sum to 1.0 (very important!)
	blend_weights /= (blend_weights.x + blend_weights.y +	blend_weights.z ).xxx;
	Out.BlendWeights=blend_weights;
	Out.Tex=Out.WPos.yz*0.005;
	Out.Tex2.zw=Out.WPos.xy*0.005;
	Out.Tex2.xy=Out.WPos.xz*0.005;


	return Out;
}


float4 PS_atmo(VS_OUTPUT In):COLOR0
{
	float4 color;

	float3 ViewerX = In.WPos.xyz - vecViewPos.xyz;	
	float3 atmo=pow(saturate(dot(In.Normal,normalize(In.View))),5.5);//*In.Diffuse;
//	atmo*=float3(0.1,0.4,1.0)*2;
	color.rgb=In.Diffuse+atmo+In.Specular;
	color.rgb=float3(0.5,0.6,1.0)*In.Diffuse;
	color.a=atmo*10*(In.Diffuse+0.85);
	return color;	
}

float4 PS_green(VS_OUTPUT In):COLOR0
{
	float4 color;
	color.rgb=float3(0.5,1.0,0.5);
	color.a=1;
	return color;	
}

technique renderTerrain
{

	pass P0
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader  = compile ps_3_0 PS();
		ZEnable = true;
		ZWriteEnable=true;
		AlphaBlendEnable = false;
		CullMode=ccw;
//		FillMode=2;
	
		//        ShadeMode=1;
//		PointSize=5;
	}	
//	pass P0
//	{
//		VertexShader = compile vs_3_0 VS();
//		PixelShader  = compile ps_3_0 PS();
//		ZEnable = true;
//		ZWriteEnable=true;
//		AlphaBlendEnable = false;
//		CullMode=0;
//		FillMode=1;
//	
//		//        ShadeMode=1;
//		PointSize=5;
//	}
//	pass P1
//	{
//		VertexShader = compile vs_3_0 VS();
//		PixelShader  = compile ps_3_0 PS_green();
//		ZEnable = true;
//		ZWriteEnable=true;
//		AlphaBlendEnable = false;
//		CullMode=CCW;
//		FillMode=2;
//		//        ShadeMode=1;
////		PointSize=10;
//	}
//	pass P2
//	{
//		VertexShader = compile vs_3_0 VS_atmo();
//		PixelShader  = compile ps_3_0 PS_atmo();
//		ZEnable = true;
//		ZWriteEnable=false;
//		AlphaBlendEnable = true;
//		CullMode=CW;
////		FillMode=2;
//		//        ShadeMode=1;
////		PointSize=10;
//	}
}